struct _Buffer
{
  char * buf;
  size_t len;
  size_t offset;
  size_t size;
};
typedef struct _Buffer Buffer;

extern int8_t  buffer_add (Buffer * b, void * data, size_t n);
extern void    buffer_clear (Buffer * b);
extern int8_t  buffer_expand (Buffer * b);
extern void    buffer_free (Buffer * b);
extern void    buffer_get (Buffer * b, void * data, size_t n);
extern int8_t  buffer_init (Buffer * b);
extern ssize_t buffer_read (Buffer * b, int fd);
extern ssize_t buffer_write (Buffer * b, int fd);
